/** \file VBasics.h */
// ############################################################################################
//  VBasics.h
//  Definition of the most basic stuffs
//  -------------------------------------------------------------------------------------------
//  Copyright (C) 2004-2006 Aloysius Indrayanto
//  This file is part of VortexGE
//
//  This library is free software; you can redistribute it and/or modify it under the terms of
//  the GNU Lesser General Public License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//
//  This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License along with this
//  library; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
//  Boston, MA 02111-1307 USA.
// ############################################################################################
#ifndef _BASE___VBASICS_H_
#define _BASE___VBASICS_H_

// Include the real stuff
#include "VGch.h"

/**
 * \mainpage VortexGE API Documentation
 *
 * Copyright (C) 2004-2006 Aloysius Indrayanto \n
 * \n
 * Permission is granted to copy, distribute and/or modify this document under
 * the terms of the GNU Free Documentation License, Version 1.2 or any later
 * version published by the Free Software Foundation; with no Invariant Sections,
 * no Front-Cover Texts, and no Back-Cover Texts.\n
 * \n
 * A copy of the license is included with the main VortexGE documentation.
 * \n
 * <hr>
 * \note This API documentation is not finished yet.
 * 
 * \defgroup Dialog_Macros        Dialog Macros
 * 
 * \defgroup VortexLua_Macros     VortexLua Macros
 * \defgroup Game_Entity_Macros   Game Entity Macros
 * \defgroup Game_Entity_IStruct  Game Entity Initialization Structures
 * 
 * \defgroup Arch_Dep_Macros      Architecture Dependent Macros
 * \defgroup Shortcut_Macros      Shortcut Macros
 * \defgroup Special_Macros       Special Macros
 * \defgroup Versioning_Macros    Versioning Macros
 * 
 * \defgroup SystemUtilities      System Utilities
 * 
 * \defgroup MsgDisplayFunctions  Message Displayer Functions
 * \defgroup DCTRelatedFunctions  DCT-Related Functions
 * 
 * \defgroup SHF_ClippingValues   Special Helper Functions for Clipping Values
 * \defgroup SHF_CopyingValues    Special Helper Functions for Copying Values
 * \defgroup SHF_UnParmSuppressor Special Helper Functions for Unused Parameter Warning Suppressor
 */

/**
 * \namespace vge
 * \brief Public namespace for all VortexGE API
 *
 * All classes, structures, functions, enumerations, typedefs and variables
 * defined here are exported for use.
 */

/**
 *  \namespace vge::xprv
 *  \brief Private namespace for all VortexGE internal API
 *
 * All classes, structures, functions, enumerations, typedefs and variables
 * defined here meant for VortexGE internal use.
 */

#endif
