// rnn.cc
// Strip two or more consecutive empty lines into only one line
//
// Copyright (C) 2004-2006 Aloysius Indrayanto
// This small utility is licensed under the GNU LGPL
//
// Usage: ./rnn in_file  [> out-file]
//
#include <stdio.h>
#include <stdlib.h>


int main(int argc, char *argv[])
{
  if(argc != 2) {
    printf("\nUsage:");
    printf("\n  %s in-file [> out-file]", argv[0]);
    printf("\n\n");
    exit(1);
  }

  FILE   *fp;
  char   *Buffer;
  int    r, c;
  bool   empty;
  size_t n;

  fp = fopen(argv[1], "rt");
  if(!fp) {
    printf("\nCouldn't open input file \"%s\"\n\n", argv[1]);
    exit(1);
  }

  c = 0;
  for(;;) {
    Buffer = NULL; n = 0;
    r = getline(&Buffer, &n, fp);
    if(r == -1) break;

    empty = true;
    for(size_t x = 0; x < size_t(r); x++) {
      if((Buffer[x] != '\n') && (Buffer[x] != '\r') &&
         (Buffer[x] != '\t') && (Buffer[x] !=  ' ') &&
         (Buffer[x] != 0x00)) {
        empty = false;
        break;
      }
    }

    if(empty) {
      if(c == 0) fputc('\n', stdout);
      c++;
    }
    else {
      c = 0;
      fputs(Buffer, stdout);
    }

    free(Buffer);
  }

  fclose(fp);
}
